object_event_add(SentryTurret,ev_create,0,"
hitDamage=8;
")

//Sentry level 2 turret object
object_event_add(global.SentryTurret2,ev_create,0,"
xoffset = sprite_xoffset
yoffset = sprite_yoffset+3
sprite_index=global.SentryTurret2S
refireTime=3;
readyToShoot=false;
noticedTarget=true;
hitDamage=8;
shooting=false;
rotating=false;
nearestTarget = noone;
alarm[0] = refireTime /global.delta_factor;
muzzleFlashing=0
");
object_event_add(global.SentryTurret2,ev_alarm,0,"
{
    readyToShoot=true;
    
}
")

object_event_add(global.SentryTurret2,ev_alarm,1,"
if nearestTarget!=noone{
muzzleFlashing=1
alarm[1]=2*refireTime/global.delta_factor
}else{
muzzleFlashing=0
}
")
object_event_clear(SentryTurret,ev_step,ev_step_end)
object_event_add(SentryTurret,ev_step,ev_step_end,"
var targetQueue, testDist, playercheck, targetAngle, obscured, rotateoffset;

if(ownerPlayer.sentry)
{
    x = ownerPlayer.sentry.x;
    y = ownerPlayer.sentry.y;
}
else
{
    instance_destroy();
    exit;
}

if(((direction+270) mod 360)>180) {
    image_xscale=1;
    image_angle = direction;
} else {
    image_xscale=-1;
    image_angle = direction+180;
}

nearestTarget = noone;
targetQueue = ds_priority_create();

// Build a queue of potential targets
with(Character) {
    testDist = distance_to_object(other);
    if(!cloak && testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

with(Sentry) {
    testDist = distance_to_object(other);
    if(testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

gunSetSolids();
while(!nearestTarget && !ds_priority_empty(targetQueue)) {
    playercheck = ds_priority_delete_min(targetQueue);
    targetAngle = point_direction(x,y,playercheck.x,playercheck.y);
    if((targetAngle <= 45 || targetAngle >= 315 || (targetAngle >= 135 && targetAngle <= 225) || place_meeting(x,y,playercheck)) 
        && playercheck.team != team 
        && playercheck.hp > 0
        && collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,TeamGate,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
            var setupGateCheck, blockedBySetupGate;
            setupGateCheck = collision_line(x,y,playercheck.x,playercheck.y,ControlPointSetupGate,true,true);
            blockedBySetupGate = true;
            if (setupGateCheck<0) { blockedBySetupGate = false; }
            else if (setupGateCheck.solid == false) { blockedBySetupGate = false; }
            if (!blockedBySetupGate) {
                // Target looks valid, but it might be obscured by a sentry.
                // That has to be tested individually because we have to exclude both this sentry and the target
                // from the collision check
                obscured = false;
                with(Sentry) {
                    if(!obscured && id != other.ownerPlayer.sentry && id != playercheck && collision_line(other.x,other.y,playercheck.x,playercheck.y,id,false,false)>=0) {
                        obscured = true;
                    }
                }
                if(!obscured) {
                    nearestTarget = playercheck;
                }
            }
        }
}
ds_priority_destroy(targetQueue);

if(!nearestTarget) {
    noticedTarget = true;
    if(image_xscale>0)
        direction = 0;
    else
        direction = 180;
        
    if image_xscale != startDirection {
        rotating=true;
    }
} else {
    // set cloaked spy as target if they're in the way
    with(Spy) {
        if(team != other.team && collision_line(other.x,other.y,other.nearestTarget.x,other.nearestTarget.y,id,true,false)>=0) {
            other.nearestTarget = id;
        }
    }
    
    if(nearestTarget.x < x && image_xscale == 1) {
        rotating=true;
    } else if(nearestTarget.x > x && image_xscale == -1) {
        rotating=true;
    }    
        
    if (noticedTarget == true) {
        playsound(x,y,SentryAlert);
        readyToShoot = false;
        alarm[0] = refireTime*2 / global.delta_factor;
    }    
    
    noticedTarget = false;
    
    if(readyToShoot && (rotating == false)) {
        direction = point_direction(x,y,nearestTarget.x,nearestTarget.y);
        
        // Prevent the turret from turning too high even if it is shooting in that direction.
        // This hides the exception to the angle restriction that occurs when a player is standing
        // directly on the sentry gun. 
        if(direction>=45 and direction<90) direction=45;
        else if(direction>=90 and direction<135) direction=135;
        else if(direction>=225 and direction<270) direction=225;
        else if(direction>=270 and direction<315) direction=315;
        
        playsound(x,y,ShotgunSnd);
        ownerPlayer.sentry.idleTimer = false;
        ownerPlayer.sentry.alarm[5] = 30 / global.delta_factor;
        
        if(nearestTarget.ubered == 0) {
            damageAuto(ownerPlayer, nearestTarget, hitDamage);
            with nearestTarget{
				motion_add(other.direction,1.5)
				moveStatus=3
				}
            if (nearestTarget.lastDamageDealer != ownerPlayer && object_is_ancestor(nearestTarget.object_index, Character)) {
                if (nearestTarget.lastDamageDealer != nearestTarget.player){
                    nearestTarget.secondToLastDamageDealer = nearestTarget.lastDamageDealer;
                    nearestTarget.alarm[4] = nearestTarget.alarm[3];
                }
            }
            nearestTarget.alarm[3] = ASSIST_TIME;
            nearestTarget.lastDamageDealer = ownerPlayer;
            nearestTarget.lastDamageSource = DAMAGE_SOURCE_SENTRYTURRET;
            if(global.gibLevel > 0 and object_is_ancestor(nearestTarget.object_index, Character))
            {
                blood = instance_create(nearestTarget.x,nearestTarget.y,Blood);
                blood.direction = direction-180;
                dealFlicker(nearestTarget);
            }
        }
        shooting=true;
        readyToShoot=false;
        alarm[0]=refireTime / global.delta_factor;
    }
}
gunUnsetSolids();

if(rotating) {
    rotateindex += 0.3 * global.delta_factor;
    if(rotateindex >= rotateend) {
        image_xscale = -image_xscale;
        direction += 180;
        rotating = false;
        rotateindex = rotatestart;
    }
}
")

object_event_add(global.SentryTurret2,ev_step,ev_step_end,"var targetQueue, testDist, playercheck, targetAngle, obscured, rotateoffset;

if(ownerPlayer.sentry)
{
    x = ownerPlayer.sentry.x;
    y = ownerPlayer.sentry.y;
}
else
{
    instance_destroy();
    exit;
}

if(((direction+270) mod 360)>180) {
    image_xscale=1;
    image_angle = direction;
} else {
    image_xscale=-1;
    image_angle = direction+180;
}

nearestTarget = noone;
targetQueue = ds_priority_create();

// Build a queue of potential targets
with(Character) {
    testDist = distance_to_object(other);
    if(!cloak && testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

with(Sentry) {
    testDist = distance_to_object(other);
    if(testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

gunSetSolids();
while(!nearestTarget && !ds_priority_empty(targetQueue)) {
    playercheck = ds_priority_delete_min(targetQueue);
    targetAngle = point_direction(x,y,playercheck.x,playercheck.y);
    if((targetAngle <= 45 || targetAngle >= 315 || (targetAngle >= 135 && targetAngle <= 225) || place_meeting(x,y,playercheck)) 
        && playercheck.team != team 
        && playercheck.hp > 0
        && collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,TeamGate,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
            var setupGateCheck, blockedBySetupGate;
            setupGateCheck = collision_line(x,y,playercheck.x,playercheck.y,ControlPointSetupGate,true,true);
            blockedBySetupGate = true;
            if (setupGateCheck<0) { blockedBySetupGate = false; }
            else if (setupGateCheck.solid == false) { blockedBySetupGate = false; }
            if (!blockedBySetupGate) {
                // Target looks valid, but it might be obscured by a sentry.
                // That has to be tested individually because we have to exclude both this sentry and the target
                // from the collision check
                obscured = false;
                with(Sentry) {
                    if(!obscured && id != other.ownerPlayer.sentry && id != playercheck && collision_line(other.x,other.y,playercheck.x,playercheck.y,id,false,false)>=0) {
                        obscured = true;
                    }
                }
                if(!obscured) {
                    nearestTarget = playercheck;
                }
            }
        }
}
ds_priority_destroy(targetQueue);

if(!nearestTarget) {
    noticedTarget = true;
    if(image_xscale>0)
        direction = 0;
    else
        direction = 180;
        
    if image_xscale != startDirection {
        rotating=true;
    }
} else {
    // set cloaked spy as target if they're in the way
    with(Spy) {
        if(team != other.team && collision_line(other.x,other.y,other.nearestTarget.x,other.nearestTarget.y,id,true,false)>=0) {
            other.nearestTarget = id;
        }
    }
    
    if(nearestTarget.x < x && image_xscale == 1) {
        rotating=true;
    } else if(nearestTarget.x > x && image_xscale == -1) {
        rotating=true;
    }    
        
    if (noticedTarget == true) {
        playsound(x,y,SentryAlert);
        readyToShoot = false;
        alarm[0] = refireTime*4 / global.delta_factor;
		alarm[1] = refireTime*4 / global.delta_factor;
    }    
    
    noticedTarget = false;
    
    if(readyToShoot && (rotating == false)) {
        direction = point_direction(x,y,nearestTarget.x,nearestTarget.y);
        
        // Prevent the turret from turning too high even if it is shooting in that direction.
        // This hides the exception to the angle restriction that occurs when a player is standing
        // directly on the sentry gun. 
        if(direction>=45 and direction<90) direction=45;
        else if(direction>=90 and direction<135) direction=135;
        else if(direction>=225 and direction<270) direction=225;
        else if(direction>=270 and direction<315) direction=315;
        
        playsound(x,y,ShotgunSnd);
        ownerPlayer.sentry.idleTimer = false;
        ownerPlayer.sentry.alarm[5] = 30 / global.delta_factor;
        
        if(nearestTarget.ubered == 0) {
            damageAuto(ownerPlayer, nearestTarget, hitDamage);
			with nearestTarget{
			motion_add(other.direction,1.5)
				moveStatus=3
				}
            if (nearestTarget.lastDamageDealer != ownerPlayer && object_is_ancestor(nearestTarget.object_index, Character)) {
                if (nearestTarget.lastDamageDealer != nearestTarget.player){
                    nearestTarget.secondToLastDamageDealer = nearestTarget.lastDamageDealer;
                    nearestTarget.alarm[4] = nearestTarget.alarm[3];
                }
            }
            nearestTarget.alarm[3] = ASSIST_TIME;
            nearestTarget.lastDamageDealer = ownerPlayer;
            nearestTarget.lastDamageSource = DAMAGE_SOURCE_SENTRYTURRET;
            if(global.gibLevel > 0 and object_is_ancestor(nearestTarget.object_index, Character))
            {
                blood = instance_create(nearestTarget.x,nearestTarget.y,Blood);
                blood.direction = direction-180;
                dealFlicker(nearestTarget);
            }
        }
        shooting=true;
        readyToShoot=false;
        alarm[0]=refireTime / global.delta_factor;
    }
}
gunUnsetSolids();

if(rotating) {
    rotateindex += 0.3 * global.delta_factor;
    if(rotateindex >= rotateend) {
        image_xscale = -image_xscale;
        direction += 180;
        rotating = false;
        rotateindex = rotatestart;
    }
}")

object_event_add(global.SentryTurret2,ev_other,ev_user0,"
if (startDirection > 0) {
    direction=0;
} else {
    direction=180;
}

if(team == TEAM_RED) {
    rotateoffset=0;
} else {
    rotateoffset=5;
}

rotatestart = rotateoffset;
rotateend = rotateoffset+4;
rotateindex = rotatestart;
")
object_event_add(global.SentryTurret2,ev_draw,0,"
if (distance_to_point(view_xview + view_wview/2, view_yview + view_hview/2) > 800)
    exit;
    
var imageOffset;
if(shooting)
{

    shooting=false;
    imageOffset=1
    if(instance_exists(nearestTarget))
    {
        xshootoffset=4*image_xscale;
        draw_set_alpha(0.6);
        draw_line_width_color(x+lengthdir_x(10,direction)-xshootoffset,y+lengthdir_y(10,direction)-2,nearestTarget.x+random(25)-12,nearestTarget.y+random(25)-12,2,c_yellow,c_black);
    }
}
else
    imageOffset=0;
    
if(ownerPlayer.sentry)
{
    if(ownerPlayer.sentry.image_index > 7)
    {
        if(rotating)
            draw_sprite_ext(global.SentryRotate2S,round(rotateindex),x,y,image_xscale,image_yscale,0,c_white,1);
        else
            draw_sprite_ext(sprite_index,3*ownerPlayer.team + imageOffset+muzzleFlashing,round(x+xoffset*image_xscale),round(y+yoffset),image_xscale,image_yscale,image_angle,c_white,1);
    }
}
")



object_event_add(global.SentryTurret3,ev_create,0,"
animFrame=0
xoffset = sprite_xoffset+2;
yoffset = sprite_yoffset-1;
sprite_index=global.SentryTurret3S
refireTime=3;
readyToShoot=false;
noticedTarget=true;
hitDamage=10;
shooting=false;
rotating=false;
nearestTarget = noone;
alarm[0] = refireTime;
muzzleFlashing=0
")
object_event_add(global.SentryTurret3,ev_alarm,0,"
{
    readyToShoot=true;
    animFrame+=0.25*global.delta_factor
    
}
")
object_event_add(global.SentryTurret3,ev_alarm,1,"
if nearestTarget!=noone{
muzzleFlashing=1
alarm[1]=2*refireTime/global.delta_factor
}else{
muzzleFlashing=0
}")
object_event_add(global.SentryTurret3,ev_step,ev_step_begin,"
if animFrame>=14{
    animFrame=0
    }else if animFrame!=0{
    animFrame+=0.25*global.delta_factor
    }
    if muzzleFlashing=1&&!rotating&&nearestTarget!=noone{
    if animFrame=1{
    playsound(x,y,RocketSnd);
var oid, newx, newy;
oid = instance_create(x+lengthdir_x(-4,direction),y+lengthdir_y(-17,direction), Rocket);
oid.lastknownx =x+lengthdir_x(-4,direction)
oid.lastknowny =y+lengthdir_y(-17,direction);
oid.direction=direction
oid.speed=18;
oid.ownerPlayer=ownerPlayer;
oid.owner=ownerPlayer.object;
oid.team=ownerPlayer.team;
oid.gun=id;
oid.weapon=DAMAGE_SOURCE_SENTRYTURRET;
if (collision_line(x,y,x+lengthdir_x(28,direction),y+lengthdir_y(28,direction),Obstacle,1,0) || place_meeting(x+lengthdir_x(25,direction),y+lengthdir_y(25,direction),TeamGate)) {
    oid.characterHit = -1;
    with (oid)
        event_user(5);
} }
    }")
object_event_add(global.SentryTurret3,ev_step,ev_step_end,"
var targetQueue, testDist, playercheck, targetAngle, obscured, rotateoffset;

if(ownerPlayer.sentry)
{
    x = ownerPlayer.sentry.x;
    y = ownerPlayer.sentry.y;
}
else
{
    instance_destroy();
    exit;
}

if(((direction+270) mod 360)>180) {
    image_xscale=1;
    image_angle = direction;
} else {
    image_xscale=-1;
    image_angle = direction+180;
}

nearestTarget = noone;
targetQueue = ds_priority_create();

// Build a queue of potential targets
with(Character) {
    testDist = distance_to_object(other);
    if(!cloak && testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

with(Sentry) {
    testDist = distance_to_object(other);
    if(testDist<=375) {
        ds_priority_add(targetQueue, id, testDist);
    }
}

gunSetSolids();
while(!nearestTarget && !ds_priority_empty(targetQueue)) {
    playercheck = ds_priority_delete_min(targetQueue);
    targetAngle = point_direction(x,y,playercheck.x,playercheck.y);
    if((targetAngle <= 45 || targetAngle >= 315 || (targetAngle >= 135 && targetAngle <= 225) || place_meeting(x,y,playercheck)) 
        && playercheck.team != team 
        && playercheck.hp > 0
        && collision_line(x,y,playercheck.x,playercheck.y,Obstacle,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,TeamGate,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,IntelGate,true,true)<0
        && collision_line(x,y,playercheck.x,playercheck.y,BulletWall,true,true)<0) {
            var setupGateCheck, blockedBySetupGate;
            setupGateCheck = collision_line(x,y,playercheck.x,playercheck.y,ControlPointSetupGate,true,true);
            blockedBySetupGate = true;
            if (setupGateCheck<0) { blockedBySetupGate = false; }
            else if (setupGateCheck.solid == false) { blockedBySetupGate = false; }
            if (!blockedBySetupGate) {
                // Target looks valid, but it might be obscured by a sentry.
                // That has to be tested individually because we have to exclude both this sentry and the target
                // from the collision check
                obscured = false;
                with(Sentry) {
                    if(!obscured && id != other.ownerPlayer.sentry && id != playercheck && collision_line(other.x,other.y,playercheck.x,playercheck.y,id,false,false)>=0) {
                        obscured = true;
                    }
                }
                if(!obscured) {
                    nearestTarget = playercheck;
                }
            }
        }
}
ds_priority_destroy(targetQueue);

if(!nearestTarget) {
    noticedTarget = true;
    if(image_xscale>0)
        direction = 0;
    else
        direction = 180;
        
    if image_xscale != startDirection {
        rotating=true;
    }
} else {
    // set cloaked spy as target if they're in the way
    with(Spy) {
        if(team != other.team && collision_line(other.x,other.y,other.nearestTarget.x,other.nearestTarget.y,id,true,false)>=0) {
            other.nearestTarget = id;
        }
    }
    
    if(nearestTarget.x < x && image_xscale == 1) {
        rotating=true;
    } else if(nearestTarget.x > x && image_xscale == -1) {
        rotating=true;
    }    
        
    if (noticedTarget == true) {
        playsound(x,y,SentryAlert);
        readyToShoot = false;
        alarm[0] = refireTime*4 / global.delta_factor;
		alarm[1] = refireTime*4 / global.delta_factor;
		alarm[2] = 2 / global.delta_factor;
    }    
    
    noticedTarget = false;
    
    if(readyToShoot && (rotating == false)) {
        direction = point_direction(x,y,nearestTarget.x,nearestTarget.y);
        
        // Prevent the turret from turning too high even if it is shooting in that direction.
        // This hides the exception to the angle restriction that occurs when a player is standing
        // directly on the sentry gun. 
        if(direction>=45 and direction<90) direction=45;
        else if(direction>=90 and direction<135) direction=135;
        else if(direction>=225 and direction<270) direction=225;
        else if(direction>=270 and direction<315) direction=315;
        
        playsound(x,y,ShotgunSnd);
        ownerPlayer.sentry.idleTimer = false;
        ownerPlayer.sentry.alarm[5] = 30 / global.delta_factor;
        
        if(nearestTarget.ubered == 0) {
            damageAuto(ownerPlayer, nearestTarget, hitDamage);
			with nearestTarget{
			motion_add(other.direction,1.5)
				moveStatus=3
				}
            if (nearestTarget.lastDamageDealer != ownerPlayer && object_is_ancestor(nearestTarget.object_index, Character)) {
                if (nearestTarget.lastDamageDealer != nearestTarget.player){
                    nearestTarget.secondToLastDamageDealer = nearestTarget.lastDamageDealer;
                    nearestTarget.alarm[4] = nearestTarget.alarm[3];
                }
            }
            nearestTarget.alarm[3] = ASSIST_TIME;
            nearestTarget.lastDamageDealer = ownerPlayer;
            nearestTarget.lastDamageSource = DAMAGE_SOURCE_SENTRYTURRET;
            if(global.gibLevel > 0 and object_is_ancestor(nearestTarget.object_index, Character))
            {
                blood = instance_create(nearestTarget.x,nearestTarget.y,Blood);
                blood.direction = direction-180;
                dealFlicker(nearestTarget);
            }
        }
        shooting=true;
        readyToShoot=false;
        alarm[0]=refireTime / global.delta_factor;
    }
}
gunUnsetSolids();

if(rotating) {
    rotateindex += 0.3 * global.delta_factor;
    if(rotateindex >= rotateend) {
        image_xscale = -image_xscale;
        direction += 180;
        rotating = false;
        rotateindex = rotatestart;
    }
}")
object_event_add(global.SentryTurret3,ev_other,ev_user0,"
if (startDirection > 0) {
    direction=0;
} else {
    direction=180;
}

if(team == TEAM_RED) {
    rotateoffset=0;
} else {
    rotateoffset=5;
}

rotatestart = rotateoffset;
rotateend = rotateoffset+4;
rotateindex = rotatestart;")
object_event_add(global.SentryTurret3,ev_draw,0,"
if (distance_to_point(view_xview + view_wview/2, view_yview + view_hview/2) > 800)
    exit;
    
var imageOffset;
if(shooting)
{

    shooting=false;
    imageOffset=1
    
    if(instance_exists(nearestTarget))
    {
        xshootoffset=4*image_xscale;
        draw_set_alpha(0.6);
        draw_line_width_color(x+lengthdir_x(10,direction)-xshootoffset,y+lengthdir_y(10,direction)-2,nearestTarget.x+random(25)-12,nearestTarget.y+random(25)-12,2,c_yellow,c_black);
    }
}
else
    imageOffset=0;
    
if(ownerPlayer.sentry)
{
    if(ownerPlayer.sentry.image_index > 7)
    {
        if(rotating){
            draw_sprite_ext(global.SentryRotate3S,round(rotateindex),x,y,image_xscale,image_yscale,0,c_white,1);
        }else{
            draw_sprite_ext(global.SentryRocketLauncherS,floor(15*ownerPlayer.team+animFrame),round(x+xoffset*image_xscale),round(y+yoffset),image_xscale,image_yscale,image_angle,c_white,1)
             draw_sprite_ext(sprite_index,3*ownerPlayer.team + imageOffset+muzzleFlashing,round(x+xoffset*image_xscale),round(y+yoffset),image_xscale,image_yscale,image_angle,c_white,1);
}
           
    }
}")
//Sentry Object Changes
object_event_add(Sentry,ev_create,0,"
level=1;
weapons[1]=SentryTurret;
weapons[2]=global.SentryTurret2;
weapons[3]=global.SentryTurret3;
buildTime=0;
upgrade=0;
sprites[0]=global.SentryRed1S;
sprites[1]=global.SentryRed2S;
sprites[2]=global.SentryRed3S;
sprites[3]=global.SentryBlue1S;
sprites[4]=global.SentryBlue2S;
sprites[5]=global.SentryBlue3S;
dispenser=0
addedHp=0
")
global.upgradeText="Upgrade %: "
global.possessive="'s"
global.autogunName="Autogun"
object_event_clear(Sentry,ev_draw,0)
object_event_add(Sentry,ev_draw,0,"


sprite_index=sprites[(level-1)+3*ownerPlayer.team]
if dispenser{
if ownerPlayer.team=TEAM_RED sprite_index=global.DispenserRedS
else sprite_index=global.DispenserBlueS
}
xr = round(x);
yr = round(y);

if global.myself.team == team && variable_global_exists(global.UpgradeableSentriesString) && level<3 draw_healthbar(xr-10, yr-30, xr+10, yr-25,upgrade*100/100,c_black,c_gray,c_white,0,true,true);
if global.myself.team == team draw_healthbar(xr-10, yr-35, xr+10, yr-30,hp*100/maxHp,c_black,c_red,c_green,0,true,true);
if (built && hp < .75 * maxHp) draw_sprite_part_ext(FlameS, random(4), 0, 0, 21, 9, xr-21/2, yr-15, 1, 1, c_white, 1 - (hp / maxHp));
draw_sprite_ext(sprite_index,image_index,xr,yr,image_xscale,image_yscale,image_angle,c_white,1);

if(distance_to_point(mouse_x, mouse_y)<25 && global.myself.team == team) {
    draw_set_alpha(1);   
    draw_set_halign(fa_center);
    draw_set_valign(fa_bottom); 
    if(team==TEAM_RED) {
        draw_set_color(c_red);
    } else {
        draw_set_color(c_blue);
    }
    draw_text(xr, yr-60, ownerPlayer.name + global.possessiveString);
    if dispenser=0 draw_text(xr, yr-50, global.AutogunString);
	else draw_text(xr, yr-50, global.DistributorString);



    if variable_global_exists(global.UpgradeableSentriesString) && dispenser=0 && level<3{
	draw_text(xr, yr-40, global.upgradeText + string(floor(upgrade*100/100)));
	}
}")
object_event_add(Sentry,ev_draw,0,"
if built&&dispenser{
with(Character){
if point_distance(x,y,other.x,other.y)<=other.dispenserMaxRange
&& hp > 0
&& collision_line(x,y,other.x,other.y,Obstacle,true,true)<0
&& collision_line(x,y,other.x,other.y,TeamGate,true,true)<0
&& collision_line(x,y,other.x,other.y,IntelGate,true,true)<0
&& collision_line(x,y,other.x,other.y,BulletWall,true,true)<0{
if team=other.team{
if team=TEAM_RED c=c_red
else c=c_blue
draw_set_alpha(0.3);
        draw_line_width_color(x,y,other.x, other.y, 5, c, c);
}
}
}
}
")
object_event_clear(Sentry,ev_step,ev_step_begin)
object_event_add(Sentry,ev_step,ev_step_begin,"
if(global.isHost and (ownerPlayer.class != CLASS_ENGINEER or team != ownerPlayer.team or collision_circle(x,y+10,25,Sentry,false,true)>=0))
{
    sendEventDestruction(ownerPlayer, noone, noone, 0);
    doEventDestruction(ownerPlayer, noone, noone, 0);
    exit;
}
maxHp=80+level*15
if (built == 0 and vspeed == 0)
{
    if (buildTime < 100){
        if level=1 buildTime += buildrate * global.delta_factor;;
        if level=2 or level=3 buildTime+=2 * buildrate * global.delta_factor;
        if addedHp<100 {
			if hp<maxHp{
				hp+=min(buildrate * global.delta_factor,abs(hp-maxHp))
				hp += buildrate * global.delta_factor;
		}
		}
    }else
        built = 1;
		 buildrate = min(buildrate, buildrate+(0.6*global.delta_factor/45)); // Buildrate increases from 0.5 to 1 over 1.5 seconds
    image_index = floor((image_number-1)*buildTime/100);
    if (landed == 0)
    {
        landed = 1;
        playsound(x,y,SentryFloorSnd);
        playsound(x,y,SentryBuildSnd);
    }  
}
if (built == 1and dispenser=1)
{
    image_index=image_number-1;
    image_speed=0;
}
if (built == 1 and currentWeapon == -1 and dispenser=0)
{
    image_index=image_number-1;
    image_speed=0;
    currentWeapon = instance_create(x,y,weapons[level]);
    currentWeapon.ownerPlayer=ownerPlayer;
    currentWeapon.team=team;
    currentWeapon.startDirection=startDirection;
    with(currentWeapon)
        event_user(0);
}
if (humiliated == 1 and built == 1 and currentWeapon != -1)
    event_user(1);

wallSetSolid();

// Try to get outside of the wallmask if we're in it.
if(!place_free(x, y))
    move_outside_solid(0, 6);
if(!place_free(x, y))
    move_outside_solid(180, 12);
if(!place_free(x, y))
{
    move_outside_solid(0, 6);
    move_outside_solid(90, 100);
}

if(place_free(x+hspeed, y+vspeed+0.6))
    vspeed += 0.6  * global.delta_factor;
if(!place_free(x+hspeed, y+vspeed) and place_free(x, y))
    event_user(2);

if(vspeed > 10)
    vspeed = 10;

wallUnsetSolid();

if(oldVspeed!=0 and vspeed==0 and global.isHost)
{
    write_ubyte(global.sendBuffer, SENTRY_POSITION);
    write_ubyte(global.sendBuffer, ds_list_find_index(global.players, ownerPlayer));
    write_ushort(global.sendBuffer, round(x*5));
    write_ushort(global.sendBuffer, round(y*5));
}

oldVspeed = vspeed;
if built=1 {
    with Character{
        if player.class=CLASS_ENGINEER && player.team=other.ownerPlayer.team{
            if(!collision_line(other.x, other.y, x, y, Obstacle, true, true) && point_distance(other.x, other.y, x, y)<50 ){

                if nutsNBolts>=1&&other.upgrade<100&& other.level<3{
					with other{
                        if hp>=maxHp{
						if variable_global_exists(global.UpgradeableSentriesString) other.nutsNBolts-=min(1,100-upgrade)&& level<3;
                            upgrade+=1
                        }else{
						other.nutsNBolts-=min(1,200-hp*2)
                            hp+=0.5
                        }
                    }
                }
				if nutsNBolts>=1&&other.level>=3{
					with other{
                        if hp<maxHp{
						other.nutsNBolts-=min(1,200-hp*2)
                            hp+=0.5
                        }
                    }
                }
            }
        }
    }
}
if upgrade>=100 && level<3 && dispenser=0{
upgrade=0
level+=1
buildTime=0
built=0
landed=0
with currentWeapon{
instance_destroy()
}
currentWeapon=-1
}")

object_event_add(Sentry,ev_other,ev_user12,"
if(global.updateType == QUICK_UPDATE or global.updateType == FULL_UPDATE) {
    write_ubyte(global.serializeBuffer, level);
    write_ubyte(global.serializeBuffer, upgrade);
    write_ubyte(global.serializeBuffer, buildTime);
}")
object_event_add(Sentry,ev_other,ev_user13,"
if(global.updateType == QUICK_UPDATE or global.updateType == FULL_UPDATE) {
    receiveCompleteMessage(global.serverSocket, 3, global.deserializeBuffer);
    level = read_ubyte(global.deserializeBuffer);
    upgrade = read_ubyte(global.deserializeBuffer);
    buildTime = read_ubyte(global.deserializeBuffer);
}")
object_event_add(Sentry,ev_destroy,0,"
if level>1{
sentrygibs=instance_create(x,y,SentryGibs);
sentrygibs.image_speed = 0;
if (team == TEAM_RED)
    sentrygibs.image_index = 0;
else
    sentrygibs.image_index = 1;
}")